%% This function helps us solve the steady-state
% ûмƷ̵
function res = RES2(x,gamma1) 
gamma2       =3.1;              % shape parameter in the Pareto distribution of income shock;
alphaone     =4/9;            % share of capital in the real sector
alphatwo     =2/9;
alphathree   =0.75;
phi          =1;                 % coefficient in labor disutility
beta         =0.996;             % discounting factor
nv           =0.2825;              % the fixed cost paid by household
del          =0.025;             % depreciation of physical capital
psi          =1;                 % the productivity of labor in sector 2
tau          =0.05;
bondd        =2.3939;
bondf        =0.0268;
z            =1;
rbf          =0.03;
epsilonmin   =1-1/gamma2;
thetmin      =1-1/gamma1;
zeta         =1-alphaone-alphatwo;
wk           = x(3)*Phi_1(thetmin,x(2),gamma1)/Phi_1(thetmin,x(1),gamma1);
rk           = 1/beta-1+del;
rho          = (alphaone/rk)^(alphaone)*(alphatwo/(wk))^(alphatwo);
epsilonstar  = (nv/zeta)^zeta/(z*rho);
q            = Fun_g(epsilonstar,epsilonmin,gamma2);
Lambda       = (1-q)*phi/wk+q*phi/x(3);
yk           = (z*rho)^(1/zeta)*(gamma2/(gamma2-1/zeta))*epsilonmin^(gamma2)*epsilonstar^(1/zeta-gamma2);
rb           = phi*(beta*wk*Lambda*Phi_1(thetmin,x(1),gamma1))^(-1)-1;
xk           = (beta*(1+rb)*x(1)*Lambda)^(-1);
xl           = (beta*(1+rb)*x(2)*Lambda)^(-1);
nk           = alphatwo*yk/wk;
yl           = psi*(alphathree*psi/x(3))^(alphathree/(1-alphathree));
nl           = alphathree*yl/x(3);
Pik          = zeta*(z*rho)^(1/zeta)*(gamma2/(gamma2-1/zeta))*epsilonmin^(gamma2)*epsilonstar^(1/zeta-gamma2);
Pil          = (1-alphathree)*yl;
c            = (1-q)*xk*Phi_2(thetmin,x(1),gamma1)+q*xl*Phi_2(thetmin,x(2),gamma1);
k            = (alphaone*wk*nk)/(alphatwo*rk);
ke           = q*k;
ku           = (1-q)*k;
tax          = tau*(wk*nk+x(3)*nl+Pik+Pil-(1-q)*nv);
g            = tax-rb*bondd-rbf*bondf;
U            = log(thetmin)+1/gamma1-(1-q)/gamma1*(thetmin/x(1))^(gamma1)-q/gamma1*(thetmin/x(2))^(gamma1)+(1-q)*log(xk)+q*log(xl)-nk-nl;
W            = U/(1-beta);
% res(1)       = bond*(1+rb)+(rk-del)*k+(Pik/(1-q)-nv)+wk*nk/(1-q)+g-tax-xk;
res(1)       = bondd*(1+rb)+(rk-del)*k+(1-tau)*(Pik/(1-q)+wk*nk/(1-q)-nv)-xk;
res(2)       = (1-q)*xk*Phi_3(thetmin,x(1),gamma1)+q*xl*Phi_3(thetmin,x(2),gamma1)-bondd;
res(3)       = bondd*(1+rb)+(rk-del)*k+(1-tau)*(Pil/q+x(3)*nl/q)+g/q-xl;

