%% this code compute the transition dynamics 
% Zhang Zhewei
% to run the code, you need to install Dynare: https://www.dynare.org/download/
% transitory shock
% welfare analysis
clc
gamma1       =2.2;              % shape parameter in the Pareto distribution of demand shock
gamma2       =3.1;              % shape parameter in the Pareto distribution of income shock;
alphaone     =4/9;              % share of capital in the real sector
alphatwo     =2/9;
alphathree   =0.75;
phi          =1;                 % coefficient in labor disutility
beta         =0.996;             % discounting factor
nv           =0.2825;              % the fixed cost paid by household
del          =0.025;             % depreciation of physical capital
psi          =1;                 % the productivity of labor in sector 2
tau          =0.05;
bondd        =2.3939;
bondf        =0.0268;
z            =1;
rbf          =0.03;
epsilonmin   =1-1/gamma2;
thetmin      =1-1/gamma1;
zeta         =1-alphaone-alphatwo;
markup       =zeta/(1-zeta);
aaa=gamma2-1/zeta;
kappa1 = 0.95;
kappa2 = 0.95;
  
%% solve the steady state under different values of uncertainty 
  
[thet10,thet20,g0,tax0,wl0,wk0,rk0,rho0,epsilonstar0,q0,Lambda0,Y0,yk0,yl0,rb0,xk0,xl0,nk0,nl0,Pik0,Pil0,c0,k0,i0,bk0,bl0,ck0,cl0] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd,bondf,tau,z,zeta,rbf);

check = Y0-c0-i0-(1-q0)*nv-rbf*bondf;
%%
save SteadyState0 thet10 thet20 g0 tax0 wl0 wk0 rk0 rho0 epsilonstar0 q0 Lambda0 Y0 rb0 xk0 xl0 nk0 nl0 Pik0 Pil0 c0 k0 i0 bk0 bl0 ck0 cl0
epsilonss = epsilonstar0;
qss = q0;
gss = g0;
save ParaSet gamma1 gamma2 alphaone alphatwo alphathree phi beta nv del psi kappa1 kappa2 epsilonmin  thetmin  bondd bondf tau zeta z epsilonss qss rbf gss;


dynare transitory_foreign_9.mod
rmdir('transitory_foreign_9','s')
rmdir('+transitory_foreign_9','s')

%% 生成一些百分比变化的数据
Wf9 = Wt(2)/Wt(1)-1;
wf9 = Wt(2);
delgf9 = gt(2)/gt(1)-1;
 
%% delete all the dynare generated files
delete xini_file.mat
delete *.log
delete *.asv
delete *dynamic.m
delete *results.mat
delete *static.m
delete *variables.m
delete *.cod
delete *.bin
delete *~
delete transitory_foreign_9.m
delete SteadyState0.mat
delete SteadyState1.mat
delete ParaSet.mat

%%
clearvars -except Wd1 delg1 Wd2 delg2 Wd3 delg3 Wd4 delg4 Wd5 delg5 Wd6 delg6 Wd7 delg7 Wd8 delg8 Wd9 delg9 Wd10 delg10 Wf1 delgf1 Wf2 delgf2 Wf3 delgf3 Wf4 delgf4 Wf5 delgf5 Wf6 delgf6 Wf7 delgf7 Wf8 delgf8 Wf9 delgf9...
    wd1 wd2 wd3 wd4 wd5 wd6 wd7 wd8 wd9 wd10 wf1 wf2 wf3 wf4 wf5 wf6 wf7 wf8 wf9