%% this code plots the transition dynamics
T=30;
%% 1
figure(1)
subplot(2,3,1)
plot(-4:T-6,[bondd*ones(4,1);real(bonddt(1:T-5))],'LineWidth',3,'color',[.2 .2 .2]);grid on; hold on
title('Bond supply','FontSize',12)
xlim([-4,T-5]);
plot(-4:T-6,bondd*ones(T-1,1),'--','LineWidth',3,'color',[.5 .5 .5])

subplot(2,3,2)
plot(-4:T-6,[Y0*ones(4,1);real(Yt(1:T-5))],'LineWidth',3,'color',[.2 .2 .2]);grid on; hold on
title('Aggregate Output','FontSize',12)
xlim([-4,T-5]);
plot(-4:T-6,Y0*ones(T-1,1),'--','LineWidth',3,'color',[.5 .5 .5])

subplot(2,3,3)
plot(-4:T-6,[c0*ones(4,1);real((ct(1:T-5)))],'LineWidth',3,'color',[.2 .2 .2]);grid on; hold on
title('Consumption','FontSize',12)
xlim([-4,T-5]);
plot(-4:T-6,c0*ones(T-1,1),'--','LineWidth',3,'color',[.5 .5 .5])

subplot(2,3,4)
plot(-4:T-6,[i0*ones(4,1);real(it(1:T-5))],'LineWidth',3,'color',[.2 .2 .2]);grid on; hold on
title('Investment','FontSize',12)
xlim([-4,T-5]);
plot(-4:T-6,i0*ones(T-1,1),'--','LineWidth',3,'color',[.5 .5 .5])

subplot(2,3,5)
plot(-4:T-6,[g0*ones(4,1);real(gt(1:T-5))],'LineWidth',3,'color',[.2 .2 .2]);grid on; hold on
title('Government spending','FontSize',12)
xlim([-4,T-5]);
plot(-4:T-6,g0*ones(T-1,1),'--','LineWidth',3,'color',[.5 .5 .5])

subplot(2,3,6)
plot(-4:T-6,[q0*ones(4,1);real(qt(1:T-5))],'LineWidth',3,'color',[.2 .2 .2]);grid on; hold on
title('Agents working in L sector','FontSize',12)
xlim([-4,T-5]);
plot(-4:T-6,q0*ones(T-1,1),'--','LineWidth',3,'color',[.5 .5 .5])

%%
figure(2)

plot(-4:T-6,[bk0*ones(4,1);real(bkt(1:T-5))],'LineWidth',2,'color',[0 .45 .74]);grid on; hold on
plot(-4:T-6,bk0*ones(T-1,1),'--','LineWidth',2,'color',[.5 .5 .5]);grid on; hold on
plot(-4:T-6,[bl0*ones(4,1);real(blt(1:T-5))],'LineWidth',2,'color',[.85 .33 .1]);grid on; hold on
plot(-4:T-6,bl0*ones(T-1,1),'--','LineWidth',2,'color',[.5 .5 .5]);grid on; hold on
title('Bond flow','FontSize',12)
xlim([-4,T-8]);
legend('K-sector','','L-sector','')

%%
figure(3)
subplot(2,2,1)
plot(-4:T-7,[0*ones(4,1);real(delc(2:T-5))],'LineWidth',3,'color',[.2 .2 .2]);grid on;
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);hold on
title('\Delta Consumption (%)','FontSize',12)
xlim([-4,T-7]);
plot(-4:T-7,delc(1)*ones(T-2,1),'--','LineWidth',3,'color',[.5 .5 .5])

subplot(2,2,2)
plot(-4:T-7,[deli(1)*ones(4,1);real(deli(2:T-5))],'LineWidth',3,'color',[.2 .2 .2]);grid on;
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);hold on
title('\Delta Investment (%)','FontSize',12)
xlim([-4,T-7]);
plot(-4:T-7,deli(1)*ones(T-2,1),'--','LineWidth',3,'color',[.5 .5 .5])

subplot(2,2,3)
plot(-4:T-7,[delq(1)*ones(4,1);real((delq(2:T-5)))],'LineWidth',2.5,'color',[.2 .2 .2]);grid on;
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);hold on
title('\Delta Unemployment rate (%)','FontSize',12)
xlim([-4,T-7]);
plot(-4:T-7,delq(1)*ones(T-2,1),'--','LineWidth',3,'color',[.5 .5 .5])

subplot(2,2,4)
plot(-4:T-7,[dely(1)*ones(4,1);real((dely(2:T-5)))],'LineWidth',3,'color',[.2 .2 .2]);grid on;
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);hold on
title('\Delta Aggregate output (%)','FontSize',12)
xlim([-4,T-7]);
plot(-4:T-7,dely(1)*ones(T-2,1),'--','LineWidth',3,'color',[.5 .5 .5])




%%
figure(4)
plot(-4:T-6,[delck(1)*ones(4,1);real((delck(1:T-5)))],'LineWidth',2.5,'color',[.2 .2 .2]);grid on;
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);hold on
plot(-4:T-6,[delcl(1)*ones(4,1);real((delcl(1:T-5)))],'-.','LineWidth',3,'color',[.2 .2 .2]);grid on; 
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);hold on
title('\Delta average consumption (%)','FontSize',12)
xlim([-4,T-5]);
legend('sector-K','sector-L')
plot(-4:T-6,delck(1)*ones(T-1,1),'--','LineWidth',3,'color',[.5 .5 .5])
