%% this code compute the transition dynamics 
% Zhang Zhewei
% to run the code, you need to install Dynare: https://www.dynare.org/download/
% transitory shock
% 
clear 
close all
gamma1       =2.23;              % shape parameter in the Pareto distribution of demand shock
gamma2       =3.1;              % shape parameter in the Pareto distribution of income shock;
alphaone     =4/9;            % share of capital in the real sector
alphatwo     =2/9;
alphathree   =0.75;
phi          =1;                 % coefficient in labor disutility
beta         =0.996;             % discounting factor
nv           =0.2825;              % the fixed cost paid by household
del          =0.025;             % depreciation of physical capital
psi          =1;                 % the productivity of labor in sector 2
tau          =0.05;
bondd        =2.3939;
bondf        =0.0268;
z            =1;
rbf          =0.03;
epsilonmin   =1-1/gamma2;
thetmin      =1-1/gamma1;
zeta         =1-alphaone-alphatwo;
markup       =zeta/(1-zeta);
aaa=gamma2-1/zeta;
kappa1 = 0.95;
kappa2 = 0.99;


%% solve the steady state under different values of uncertainty 
  
[thet10,thet20,g0,tax0,wl0,wk0,rk0,rho0,epsilonstar0,q0,Lambda0,Y0,yk0,yl0,rb0,xk0,xl0,nk0,nl0,Pik0,Pil0,c0,k0,i0,bk0,bl0,ck0,cl0] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd,bondf,tau,z,zeta,rbf);

check = Y0-c0-i0-(1-q0)*nv-rbf*bondf;
%%
save SteadyState0 thet10 thet20 g0 tax0 wl0 wk0 rk0 rho0 epsilonstar0 q0 Lambda0 Y0 rb0 xk0 xl0 nk0 nl0 Pik0 Pil0 c0 k0 i0 bk0 bl0 ck0 cl0
epsilonss = epsilonstar0;
qss = q0;
gss = g0;
save ParaSet gamma1 gamma2 alphaone alphatwo alphathree phi beta nv del psi kappa1 kappa2 epsilonmin  thetmin  bondd bondf tau zeta z epsilonss qss rbf gss;

dynare TransPath_Benchmark_transitory.mod
% dynare TransPath_Benchmark_transitory_ver2.mod
rmdir('TransPath_Benchmark_transitory','s')
rmdir('+TransPath_Benchmark_transitory','s')

%% һЩٷֱȱ仯
delg = 100*gt./gt(1)-100;
delc = 100*ct./ct(1)-100;
delck = 100*ckt./ckt(1)-100;
delcl = 100*clt./clt(1)-100;
deli = 100*it./it(1)-100;
dely = 100*Yt./Yt(1)-100;
delb = 100*bonddt./bonddt(1)-100;
delbk = 100*bkt./bkt(1)-100;
delbl = 100*blt./blt(1)-100;
delq = 100*qt./qt(1)-100;
delrb = rbt-rbt(1);
liquid = gamma1t./(gamma1t+1)./thetmint-gamma1t.*(thetmint).^(gamma1t)./(gamma1t+1).*((1-qt).*thet1t.^(-gamma1t-1)+qt.*thet2t.^(-gamma1t-1));
mc = 1./rhot;
delxk = 100*xkt./xkt(1)-100;
delxl = 100*xlt./xlt(1)-100;
delnk = 100*nkt./nkt(1)-100;
delnl = 100*nlt./nlt(1)-100;
delmc = 100*mc./mc(1)-100;
thet1t1 = thet1t;
thet2t1 = thet2t;
totalbk = bkt.*(1-qt);
totalbl = blt.*(qt);
%% ͼ
% RunPlot % plot transition dynamics
%RunSolutionCheck % check whether the solution of transition path is accurate
 
%% delete all the dynare generated files
delete xini_file.mat
delete *.log
delete *.asv
delete *dynamic.m
delete *results.mat
delete *static.m
delete *variables.m
delete *.cod
delete *.bin
delete *~
delete TransPath_Benchmark_transitory.m
delete SteadyState0.mat
delete SteadyState1.mat
delete ParaSet.mat