%% this code compute the transition dynamics 
% Zhang Zhewei
% to run the code, you need to install Dynare: https://www.dynare.org/download/
% transitory shock
% 
clear 
close all
gamma1       =2.2;              % shape parameter in the Pareto distribution of demand shock
gamma2       =3.1;              % shape parameter in the Pareto distribution of income shock;
alphaone     =4/9;            % share of capital in the real sector
alphatwo     =2/9;
alphathree   =0.75;
phi          =1;                 % coefficient in labor disutility
beta         =0.996;             % discounting factor
nv           =0.2825;              % the fixed cost paid by household
del          =0.025;             % depreciation of physical capital
psi          =1;                 % the productivity of labor in sector 2
tau          =0.05;
bondd        =2.3939;
bondf        =0.0268;
z            =1;
rbf          =0.03;
epsilonmin   =1-1/gamma2;
thetmin      =1-1/gamma1;
zeta         =1-alphaone-alphatwo;
markup       =zeta/(1-zeta);
aaa=gamma2-1/zeta;
kappa1 = 0.95;
kappa2 = 0.99;


%% solve the steady state under different values of bond ratio 
  
[thet10,thet20,g0,tax0,wl0,wk0,rk0,rho0,epsilonstar0,q0,Lambda0,Y0,yk0,yl0,rb0,xk0,xl0,nk0,nl0,Pik0,Pil0,c0,k0,i0,bk0,bl0,ck0,cl0] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd,bondf,tau,z,zeta,rbf);
byratio0 = (bondd+bondf)/Y0;
df0 = bondd/(bondd+bondf);
%%
bondd = 2.3908;
bondf = 0.0299;
df1 = bondd/(bondd+bondf);
[thet11,thet21,g1,tax1,wl1,wk1,rk1,rho1,epsilonstar1,q1,Lambda1,Y1,yk1,yl1,rb1,xk1,xl1,nk1,nl1,Pik1,Pil1,c1,k1,i1,bk1,bl1,ck1,cl1] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd,bondf,tau,z,zeta,rbf);
byratio1 = (bondd+bondf)/Y1;
%%
bondd = 2.3866;
bondf = 0.0341;
df2 = bondd/(bondd+bondf);
[thet12,thet22,g2,tax2,wl2,wk2,rk2,rho2,epsilonstar2,q2,Lambda2,Y2,yk2,yl2,rb2,xk2,xl2,nk2,nl2,Pik2,Pil2,c2,k2,i2,bk2,bl2,ck2,cl2] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd,bondf,tau,z,zeta,rbf);
byratio2 = (bondd+bondf)/Y2;
%%
bondd = 2.381;
bondf = 0.0397;
df3 = bondd/(bondd+bondf);
[thet13,thet23,g3,tax3,wl3,wk3,rk3,rho3,epsilonstar3,q3,Lambda3,Y3,yk3,yl3,rb3,xk3,xl3,nk3,nl3,Pik3,Pil3,c3,k3,i3,bk3,bl3,ck3,cl3] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd,bondf,tau,z,zeta,rbf);
byratio3 = (bondd+bondf)/Y3;
%%
bondd = 2.375;
bondf = 0.0457;
df4 = bondd/(bondd+bondf);
[thet14,thet24,g4,tax4,wl4,wk4,rk4,rho4,epsilonstar4,q4,Lambda4,Y4,yk4,yl4,rb4,xk4,xl4,nk4,nl4,Pik4,Pil4,c4,k4,i4,bk4,bl4,ck4,cl4] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd,bondf,tau,z,zeta,rbf);
byratio4 = (bondd+bondf)/Y4;
%%
bondd = 2.3617;
bondf = 0.059;
df5 = bondd/(bondd+bondf);
[thet15,thet25,g5,tax5,wl5,wk5,rk5,rho5,epsilonstar5,q5,Lambda5,Y5,yk5,yl5,rb5,xk5,xl5,nk5,nl5,Pik5,Pil5,c5,k5,i5,bk5,bl5,ck5,cl5] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd,bondf,tau,z,zeta,rbf);
byratio5 = (bondd+bondf)/Y5;
%%
bondd = 2.3426;
bondf = 0.0781;
df6 = bondd/(bondd+bondf);
[thet16,thet26,g6,tax6,wl6,wk6,rk6,rho6,epsilonstar6,q6,Lambda6,Y6,yk6,yl6,rb6,xk6,xl6,nk6,nl6,Pik6,Pil6,c6,k6,i6,bk6,bl6,ck6,cl6] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd,bondf,tau,z,zeta,rbf);
byratio6 = (bondd+bondf)/Y6;
%%
bondd = 2.3054;
bondf = 0.1153;
df7 = bondd/(bondd+bondf);
[thet17,thet27,g7,tax7,wl7,wk7,rk7,rho7,epsilonstar7,q7,Lambda7,Y7,yk7,yl7,rb7,xk7,xl7,nk7,nl7,Pik7,Pil7,c7,k7,i7,bk7,bl7,ck7,cl7] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd,bondf,tau,z,zeta,rbf);
byratio7 = (bondd+bondf)/Y7;
%%
bondd = 2.2006;
bondf = 0.2201;
df8 = bondd/(bondd+bondf);
[thet18,thet28,g8,tax8,wl8,wk8,rk8,rho8,epsilonstar8,q8,Lambda8,Y8,yk8,yl8,rb8,xk8,xl8,nk8,nl8,Pik8,Pil8,c8,k8,i8,bk8,bl8,ck8,cl8] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd,bondf,tau,z,zeta,rbf);
byratio8 = (bondd+bondf)/Y8;
%%
bondd = 1.2104;
bondf = 1.2104;
df9 = bondd/(bondd+bondf);
[thet19,thet29,g9,tax9,wl9,wk9,rk9,rho9,epsilonstar9,q9,Lambda9,Y9,yk9,yl9,rb9,xk9,xl9,nk9,nl9,Pik9,Pil9,c9,k9,i9,bk9,bl9,ck9,cl9] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd,bondf,tau,z,zeta,rbf);
byratio9 = (bondd+bondf)/Y9;

%%
df = [df1 df2 df3 df4 df5 df6 df7 df8 df9];
Y = [Y1 Y2 Y3 Y4 Y5 Y6 Y7 Y8 Y9];
delY = 100*(Y-Y0)./Y0;
c = [c1 c2 c3 c4 c5 c6 c7 c8 c9];
delc = 100*(c-c0)./c0; 
i = [i1 i2 i3 i4 i5 i6 i7 i8 i9];
deli = 100*(i-i0)./i0;
thet1 = [thet11 thet12 thet13 thet14 thet15 thet16 thet17 thet18 thet19];
delthet1 = 100*(thet1-thet10)./thet10;
thet2 = [thet21 thet22 thet23 thet24 thet25 thet26 thet27 thet28 thet29];
delthet2 = 100*(thet2-thet20)./thet20;
q = [q1 q2 q3 q4 q5 q6 q7 q8 q9].*100;
delq = 100*(q-q0)./q0;
%%
figure(1)
set(gcf,'position',[180,60,800,600]);
subplot(2,3,1)
plot(df,delY,'LineWidth',2,'color',[0 0 0]);grid on;hold on
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);grid off;hold on
title({'ܲ',''},'FontSize',12,'Fontname','')
set(gca,'xTick',0.5:0.25:1);
set(gca,'xTickLabel',{'0.5','0.75','1'})

subplot(2,3,2)
plot(df,delc,'LineWidth',2,'color',[0 0 0]);grid on;hold on
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);grid off;hold on
title({'',''},'FontSize',12,'Fontname','')
set(gca,'xTick',0.5:0.25:1);
set(gca,'xTickLabel',{'0.5','0.75','1'})

subplot(2,3,3)
plot(df,deli,'LineWidth',2,'color',[0 0 0]);grid on;hold on
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);grid off;hold on
title({'Ͷ',''},'FontSize',12,'Fontname','')
set(gca,'xTick',0.5:0.25:1);
set(gca,'xTickLabel',{'0.5','0.75','1'})

subplot(2,3,4)
plot(df,thet1,'LineWidth',2,'color',[0 0 0]);grid on;hold on
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);grid off;hold on
title({'Hٽֵ',''},'FontSize',12,'Fontname','')
set(gca,'xTick',0.5:0.25:1);
set(gca,'xTickLabel',{'0.5','0.75','1'})

subplot(2,3,5)
plot(df,thet2,'LineWidth',2,'color',[0 0 0]);grid on;hold on
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);grid off;hold on
title({'Lٽֵ',''},'FontSize',12,'Fontname','')
xlabel('ȫʲռʶ','FontSize',12)
set(gca,'xTick',0.5:0.25:1);
set(gca,'xTickLabel',{'0.5','0.75','1'})

subplot(2,3,6)
plot(df,q,'LineWidth',2,'color',[0 0 0]);grid on;hold on
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);grid off;hold on
title({'HŽ',''},'FontSize',12,'Fontname','')
set(gca,'xTick',0.5:0.25:1);
set(gca,'xTickLabel',{'0.5','0.75','1'})


