clear 
close all
gamma1       =2.2;              % shape parameter in the Pareto distribution of demand shock
gamma2       =3.1;              % shape parameter in the Pareto distribution of income shock;
alphaone     =4/9;            % share of capital in the real sector
alphatwo     =2/9;
alphathree   =0.75;
phi          =1;                 % coefficient in labor disutility
beta         =0.996;             % discounting factor
nv           =0.2825;              % the fixed cost paid by household
del          =0.025;             % depreciation of physical capital
psi          =1;                 % the productivity of labor in sector 2
tau          =0.05;
bondd0        =2.3939;
bondf0        =0.0268;
z            =1;
rbf          =0.03;
epsilonmin   =1-1/gamma2;
thetmin      =1-1/gamma1;
zeta         =1-alphaone-alphatwo;
markup       =zeta/(1-zeta);
aaa=gamma2-1/zeta;
kappa1 = 0.95;
kappa2 = 0.99;
for i=1:20
    bondd(i)=bondd0-0.05917*i;
    bondf(i)=bondf0+0.05917*i;
    [thet10(i),thet20(i),g0(i),tax0(i),wl0(i),wk0(i),rk0(i),rho0(i),epsilonstar0(i),q0(i),Lambda0(i),Y0(i),yk0(i),yl0(i),rb0(i),xk0(i),xl0(i),nk0(i),nl0(i),Pik0(i),Pil0(i),c0(i),k0(i),i0(i),bk0(i),bl0(i),ck0(i),cl0(i)] = ...
SolveAllSteadyState(gamma1,gamma2,alphaone,alphatwo,alphathree,phi,beta,nv,del,psi,epsilonmin,thetmin,bondd(i),bondf(i),tau,z,zeta,rbf);
end

%%
nn = 20;
consumption = ones(nn,10000);
uni = ones(nn,10000);
rthet = ones(nn,10000);
thetcoeff = ones(nn,10000);
consumption = ones(nn,10000);
%%
for i = 1:nn
unem(i) =  round(q0(i),3);
unem(i) =  unem(i)*10000
em(i) = 10000-unem(i);
uni(i,:) = [rand(1,unem(i)),rand(1,em(i))];
rthet(i,:) = thetmin*(1-uni(i,:)).^(-1/gamma1);
thetcoeff(i,1:unem(i)) = thet20(i).*(rthet(i,1:unem(i))>=thet20(i))+rthet(i,1:unem(i)).*(rthet(i,1:unem(i))<thet20(i));
a(i) = unem(i)+1;
thetcoeff(i,a(i):10000) = thet10(i).*(rthet(i,a(i):10000)>=thet10(i))+rthet(i,a(i):10000).*(rthet(i,a(i):10000)<thet10(i));
thetcoeff(i,:)=[thetcoeff(i,1:unem(i)),thetcoeff(i,a(i):10000)];
consumption(i,a(i):10000) = thetcoeff(i,a(i):10000).*xk0(i);
consumption(i,1:unem(i)) = thetcoeff(i,1:unem(i)).*xl0(i);
consumption(i,:) = [consumption(i,1:unem(i)),consumption(i,a(i):10000)];
varofc = var(consumption,1,2);
end
%%
df = bondd./(bondd+bondf);
figure(1)
set(gcf,'position',[100 100 500 200])
subplot(1,2,1)
plot(df,varofc,'LineWidth',2,'color',[0 0 0]);grid off;
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);hold on
title({'消费方差',''},'FontSize',10,'Fontname','仿宋')
xlabel('安全资产占总融资额比例','FontSize',8)

subplot(1,2,2)
plot(df,c0,'LineWidth',2,'color',[0 0 0]);grid off;
set(gca,'GridLineStyle',':','GridColor','k','GridAlpha',1);hold on
title({'消费均值',''},'FontSize',10,'Fontname','仿宋')
xlabel('安全资产占总融资额比例','FontSize',8)